<!-- Copyright 2019 The Chromium Authors. All rights reserved.
     Use of this source code is governed by a BSD-style license that can be
     found in the LICENSE file. -->

<link rel="import" href="chrome://resources/cr_elements/cr_icon_button/cr_icon_button.html">
<link rel="import" href="chrome://resources/cr_elements/icons.html">
<link rel="import" href="chrome://resources/html/action_link.html">

<link rel="import" href="/components/common_styles.html">
<link rel="import" href="/components/hd_iron_icon.html">
<link rel="import" href="/components/oobe_i18n_behavior.html">
<link rel="import" href="/components/oobe_dialog.html">
<link rel="import" href="/components/throbber_notice.html">

<dom-module id="gaia-signin-element">
  <template>
    <style include="oobe-dialog-host"></style>
    <link rel="stylesheet" href="oobe_popup_overlay.css">
    <link rel="stylesheet" href="screen_gaia_signin.css">
    <!-- As this dialog have pre-loading logic that require access to elements,
         dialog is marked as no-lazy. -->
    <oobe-dialog id="signin-frame-dialog" class="gaia-dialog" role="dialog"
        has-buttons="[[!isSamlSsoVisible_]]"
        no-header no-footer-padding no-lazy
        for-step="online-gaia, gaia-loading">
      <div slot="footer" class="flex layout vertical">
        <div id="signin-frame-container" transparent$="[[isLoadingUiShown_]]"
            animated-transparency$="[[!usedSaml_]]"
            hideshadows$="[[isPopUpOverlayVisible_]]"
            class="flex layout vertical">
          <div id="saml-notice-container"
               class="layout horizontal center"
               hidden="[[!isSamlSsoVisible_]]">
            <div class="flex layout horizontal center-justified">
              <span id="saml-notice-recording-indicator"
                  hidden="[[!videoEnabled_]]">
                <img src="chrome://theme/IDR_TAB_RECORDING_INDICATOR">
              </span>
              <span id="saml-notice-message"></span>
            </div>
            <cr-icon-button id="saml-close-button" iron-icon="cr:close"
                on-click="cancel">
            </cr-icon-button>
          </div>
          <webview id="signin-frame" class="flex"
              name="signin-frame"></webview>
        </div>
      </div>
      <div slot="back-navigation">
        <oobe-back-button id="signin-back-button"
            disabled="[[!navigationEnabled_]]"
            on-click="onBackButtonClicked_">
        </oobe-back-button>
      </div>
      <div slot="bottom-buttons">
        <oobe-text-button id="secondary-action-button"
            label-for-aria="[[secondaryActionButtonLabel_]]"
            on-click="onSecondaryActionButtonClicked_"
            hidden="[[!secondaryActionButtonLabel_]]"
            disabled="[[!secondaryActionButtonEnabled_]]">
          <div slot="text">[[secondaryActionButtonLabel_]]</div>
        </oobe-text-button>
        <oobe-text-button id="primary-action-button"
            label-for-aria="[[primaryActionButtonLabel_]]"
            on-click="onPrimaryActionButtonClicked_"
            hidden="[[!primaryActionButtonLabel_]]"
            disabled="[[!primaryActionButtonEnabled_]]"
            inverse>
            <div slot="text">[[primaryActionButtonLabel_]]</div>
        </oobe-text-button>
      </div>
    </oobe-dialog>
    <security-token-pin id="pinDialog" parameters="[[pinDialogParameters_]]"
        for-step="pin" on-cancel="onPinDialogCanceled_"
        on-completed="onPinDialogCompleted_">
    </security-token-pin>
    <oobe-dialog id="saml-interstitial" role="dialog" has-buttons
        title-key="loginWelcomeMessage" for-step="saml-interstitial">
      <hd-iron-icon slot="oobe-icon" icon1x="oobe-32:googleg"
          icon2x="oobe-64:googleg">
      </hd-iron-icon>
      <div slot="subtitle" hidden="[[isEmpty_(samlInterstitialDomain_)]]">
        <iron-icon class="icon20" icon="cr20:domain"></iron-icon>
        [[i18nDynamic(locale, 'samlInterstitialMessage',
                      samlInterstitialDomain_)]]
        <p>
          <a class="oobe-local-link" on-click="onSamlPageChangeAccount_"
              id="interstitial-change-account" is="action-link">
            [[i18nDynamic(locale, 'samlInterstitialChangeAccountLink')]]
          </a>
        </p>
      </div>
      <div slot="back-navigation">
        <oobe-back-button id="interstitial-back"
            on-click="onBackButtonClicked_"></oobe-back-button>
      </div>
      <div slot="bottom-buttons">
        <oobe-next-button on-click="onSamlInterstitialNext_"
            id="interstitial-next" class="focus-on-show"></oobe-next-button>
      </div>
    </oobe-dialog>
    <div id="gaia-loading" class="layout center center-justified vertical fit"
        for-step="loading, gaia-loading">
      <throbber-notice text-key="gaiaLoading"></throbber-notice>
    </div>
    <notification-card id="gaia-allowlist-error" type="fail" class="fit"
        for-step="allowlist-error"
        button-label="[[i18nDynamic(locale, 'tryAgainButton')]]"
        link-label="[[i18nDynamic(locale, 'learnMoreButton')]]">
    </notification-card>
    <div class="popup-overlay"
        hidden="[[!isPopUpOverlayVisible_]]">
    </div>
  </template>
</dom-module>
